import { DomIteratorOptions } from './domIterator';
import { IndefiniteNodePredicate, NodePredicate } from './util';
export interface Options {
    addedClass?: string;
    ignoreCase?: boolean;
    modifiedClass?: string;
    removedClass?: string;
    skipChildren?: IndefiniteNodePredicate;
    skipSelf?: IndefiniteNodePredicate;
}
export interface Config extends Options, DomIteratorOptions {
    readonly addedClass: string;
    readonly ignoreCase: boolean;
    readonly modifiedClass: string;
    readonly removedClass: string;
    readonly skipChildren: NodePredicate;
    readonly skipSelf: NodePredicate;
}
export declare function optionsToConfig({ addedClass, ignoreCase, modifiedClass, removedClass, skipChildren, skipSelf }?: Options): Config;
